@ECHO OFF
REM * =========================================================== *
REM * This script is placed into the public domain by its author. *
REM * All copyrights are hereby relinquished on the routines and  *
REM * data in this file.   -- James Pujals (DZ-Jay), 2015         *
REM * =========================================================== *

ECHO jzIntv Debugger Run Script (INTYDBUG.BAT)
ECHO   Created by:   DZ-Jay
ECHO   Last updated: 07/13/2015
ECHO.

SETLOCAL

REM ========================================
REM Initialize Build Variables
REM ========================================
SET BASEPATH=%INTYBASIC_INSTALL%
	IF NOT EXIST "%BASEPATH%" GOTO BAD-INSTALL

SET BINDIR=%BASEPATH%\bin
SET ROMDIR=%BASEPATH%\bin\roms
SET EMUL=%BINDIR%\jzintv.exe

REM ========================================
REM Initialize Input Variables
REM ========================================
SET OLDDIR=%CD%
SET FDIR=%~dp1
SET FFULL=%~f1
SET FNAME=%~n1
SET FFNM=%~nx1
SET HARG=%1

REM ========================================
REM Check Source File Arguments
REM ========================================
:CHECK-HELP
IF "%HARG%"=="/h" GOTO EMUL-HELP
IF "%HARG%"=="-h" GOTO EMUL-HELP
IF "%HARG%"=="--help" GOTO EMUL-HELP

REM ========================================
REM Check Source File Arguments
REM ========================================
:TEST-INPUT
IF "%FNAME%"=="" GOTO BAD-FILENAME
IF NOT EXIST "%FDIR%bin" GOTO BAD-FILENAME

REM ========================================
REM Execute Emulator
REM ========================================
:EXEC
	CD "%FDIR%"
	SET DBOPT=--src-map="bin\%FNAME%.map" --sym-file="bin\%FNAME%.sym"

	"%EMUL%" -d -e "%ROMDIR%\miniexec.bin" -g "%ROMDIR%\minigrom.bin" --displaysize=3 -v1 %2 %3 %4 %5 %6 %7 %8 %9 %DBOPT% "bin\%FNAME%"

	IF %ERRORLEVEL% NEQ 0 GOTO ERROR-EXEC
	GOTO END

REM ========================================
REM Error Handlers
REM ========================================
:BAD-DOCSDIR
	ECHO Unable to determine "Documents" directory.
	GOTO ERROR

:BAD-INSTALL
	ECHO Unable to find IntyBASIC installation directory.
	GOTO ERROR

:BAD-FILENAME
	ECHO File not found "%FFNM%"
	GOTO USAGE

:EMUL-HELP
	"%EMUL%" -h | MORE
	IF %ERRORLEVEL% NEQ 0 GOTO ERROR-EXEC
	GOTO END

:USAGE
	ECHO Usage: intyrun [FILE.ROM]
	GOTO END

:ERROR-EXEC
	ECHO.
	ECHO jzIntv execution failed.
	GOTO ERROR

:ERROR
	ECHO Emulator execution aborted.

:END
	CD %OLDDIR%
	ECHO.
